exports.type = "group";
exports.name = "Ideker Lab";
exports.organization = "UCSD";
exports.foregroundImg = "treyideker.jpg";
exports.backgroundImg = "idekerlab.jpg";
exports.description = "Our research focuses on using genome-scale measurements to construct computer-aided models of cellular processes and disease.  These models have the potential to revolutionize biology and medicine by providing a blueprint of normal and diseased cell functions and by allowing researchers to simulate the effects of drugs on cells long before they are tested in humans. The Ideker Lab is a member of both the San Diego Center for Systems Biology (SDCSB) and the National Resource for Network Biology (NRNB).";
exports.networks = [

"CELL_MAP.TGFBR.544338.jdex",
"NCI_NATURE.Alpha9 beta1 integrin signaling events.517156.jdex",
"NCI_NATURE.Arf6 downstream pathway.517163.jdex",
"NCI_NATURE.Arf6 signaling events.517132.jdex",
"NCI_NATURE.Arf6 trafficking events.517193.jdex",
"NCI_NATURE.Beta1 integrin cell surface interactions.517095.jdex",
"NCI_NATURE.Class I PI3K signaling events mediated by Akt.517226.jdex",
"NCI_NATURE.Class I PI3K signaling events.517131.jdex",
"NCI_NATURE.EGF receptor (ErbB1) signaling pathway.517128.jdex",
"NCI_NATURE.EGFR-dependent Endothelin signaling events.517181.jdex",
"NCI_NATURE.Endothelins.517197.jdex",
"NCI_NATURE.ErbB receptor signaling network.517151.jdex",
"NCI_NATURE.ErbB1 downstream signaling.517180.jdex",
"NCI_NATURE.FoxO family signaling.517135.jdex",
"NCI_NATURE.GMCSF-mediated signaling events.517039.jdex",
"NCI_NATURE.Glypican 1 network.517070.jdex",
"NCI_NATURE.Glypican pathway.517037.jdex",
"NCI_NATURE.IFN-gamma pathway.517107.jdex",
"NCI_NATURE.IGF1 pathway.517060.jdex",
"NCI_NATURE.IL3-mediated signaling events.517142.jdex",
"NCI_NATURE.IL5-mediated signaling events.517205.jdex",
"NCI_NATURE.Insulin Pathway.517044.jdex",
"NCI_NATURE.Integrin family cell surface interactions.517077.jdex",
"NCI_NATURE.Internalization of ErbB1.517087.jdex",
"NCI_NATURE.LKB1 signaling events.517227.jdex",
"NCI_NATURE.Nectin adhesion pathway.517050.jdex",
"NCI_NATURE.PAR1-mediated thrombin signaling events.517109.jdex",
"NCI_NATURE.PDGF receptor signaling network.517075.jdex",
"NCI_NATURE.PDGFR-beta signaling pathway.517118.jdex",
"NCI_NATURE.Plasma membrane estrogen receptor signaling.517134.jdex",
"NCI_NATURE.Proteoglycan syndecan-mediated signaling events.517215.jdex",
"NCI_NATURE.S1P1 pathway.517172.jdex",
"NCI_NATURE.Signaling events mediated by Hepatocyte Growth Factor Receptor (c-Met).517069.jdex",
"NCI_NATURE.Signaling events mediated by VEGFR1 and VEGFR2.517094.jdex",
"NCI_NATURE.Signaling events mediated by focal adhesion kinase.517152.jdex",
"NCI_NATURE.Sphingosine 1-phosphate (S1P) pathway.517213.jdex",
"NCI_NATURE.Syndecan-1-mediated signaling events.517032.jdex",
"NCI_NATURE.TRAIL signaling pathway.517058.jdex",
"NCI_NATURE.Thrombin protease-activated receptor (PAR) pathway.517130.jdex",
"NCI_NATURE.Urokinase-type plasminogen activator (uPA) and uPAR-mediated signaling.517097.jdex",
"NCI_NATURE.VEGF and VEGFR signaling network.517153.jdex",
"NCI_NATURE.mTOR signaling pathway.517149.jdex",
"REACTOME.Cell Cycle, Mitotic.485623.jdex",
"REACTOME.Cyclin D associated events in G1.485628.jdex",
"REACTOME.G0 and Early G1.485619.jdex",
"REACTOME.G1 Phase.485618.jdex",
"REACTOME.Mitotic G1-G1 S phases.485622.jdex"
];

exports.bench = [

];